<?php

namespace FiloBlu\Newsletter\Block\LandingPage;

use Magento\Newsletter\Model\SubscriberFactory;

class Form extends \Magento\Framework\View\Element\Template {

    /**
     * Helper
     *
     * @var \FiloBlu\Newsletter\Helper\Data
     */
    public $_helper;
    public $_directoryBlock;
    protected $_storeManager;

    /**
     * @var \Magento\Customer\Model\Session
     */
    protected $_customerSession;
    
    protected $_coreRegistry;

    public function __construct(
    \Magento\Framework\View\Element\Template\Context $context, array $data = [], \FiloBlu\Newsletter\Helper\Data $helper, \Magento\Directory\Block\Data $directoryBlock, \Magento\Customer\Model\Session $customerSession, SubscriberFactory $subscriberFactory, \Magento\Framework\Registry $registry
    ) {
        $this->_helper = $helper;
        $this->_directoryBlock = $directoryBlock;
        $this->_storeManager = $context->getStoreManager();
        $this->_customerSession = $customerSession;
        $this->_subscriberFactory = $subscriberFactory;
        $this->_coreRegistry = $registry;
        parent::__construct($context, $data);
    }

    public function getCountries() {
        $country = $this->_directoryBlock->getCountryHtmlSelect();
        return $country;
    }

    public function getCustomerInfo() {
        if ($this->_customerSession->isLoggedIn()) {
            return $this->_customerSession->getCustomer();
        } else {
            return false;
        }
    }

    /**
     * Retrieve form action url and set "secure" param to avoid confirm
     * message when we submit form from secure page to unsecure
     *
     * @return string
     */
    public function getFormActionUrl() {
        return $this->getUrl('newsletterajax/subscriber/newlandingaction', ['_secure' => true]);
    }
    
    public function getLandingPage() {
        
        if (!$this->getLandingPageEntity()) {
            $this->setLandingPageEntity($this->_coreRegistry->registry('newsletter_landingpage_entity'));
        }

        return $this->getLandingPageEntity()->getData();
    }
    
    protected function _toHtml() {

        if (!$this->_helper->getConfig("general/enabled")) {
            return "";
        } else {
            return parent::_toHtml();
        }
    }


}
